Subject: Inject annotations should not be used by core (~5% performance)

Description

The case:

Using inject annotations requires the Reflection framework to do expensive runtime analysis of all classes that get loaded (given: only
once, if they are Singletons). This extra overhead (I measured it to around 5% in a pretty basic environment with a few extbase
plugins) can be very easily avoided by always using injection methods.

| would personally have the core's classes always use injection methods to increase performance of the base system - and warn users
in documentation, that inject annotations should be expected to slow down the code by approximately 5% (also affecting cached
contexts, especially affecting the backend).

In our quest for better performance we can take this very easy path without any damage.

A revert merge request is coming right up.

History

#1 - 2013-12-27 13:52 - Gerrit Code Review

- Status changed from New to Under Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/26565

#2 - 2013-12-27 14:11 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/26565

#3 - 2013-12-27 14:12 - Markus Klein

Please check if #52040 should be reverted as well then.

Maybe also search the complete log for such @inject changes.
#4 - 2014-04-03 11:23 - Marc Bastian Heinrichs
- Category set to Extbase

- Assigned To set to Marc Bastian Heinrichs

- Target version set to next-patchlevel

- Parent task set to #55656

#5 - 2014-04-03 11:24 - Marc Bastian Heinrichs

I'm on evaluating this and have a new patchset in the pipeline.

#6 - 2014-04-14 14:52 - Gerrit Code Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/29453
